package com.sun.xml.internal.ws.client.sei;

import javax.xml.ws.WebServiceException;
import javax.xml.ws.AsyncHandler;
import java.util.concurrent.Future;
import java.lang.reflect.Method;

final class CallbackMethodHandler extends AsyncMethodHandler
{
    private final int handlerPos;
    
    CallbackMethodHandler(SEIStub owner, Method m, int handlerPos) {
        super(owner, m);
        this.handlerPos = handlerPos;
    }
    
    @Override
    Future<?> invoke(Object proxy, Object[] args) throws WebServiceException {
        AsyncHandler handler = (AsyncHandler)args[this.handlerPos];
        return this.doInvoke(proxy, args, handler);
    }
}
